SystemOrganization addCategory: #'Rizel-Core'!

Object subclass: #RzDummy
	instanceVariableNames: 'x y model last'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Core'!

!RzDummy class methodsFor: 'as yet unclassified' stamp: ''!
x: t1 y: t2 
	| t3 |
	t3 := self new.
	t3 x: t1.
	t3 y: t2.
	^ t3! !

!RzDummy class methodsFor: 'as yet unclassified' stamp: ''!
x: t1 y: t2 model: t3 
	| t4 |
	t4 := self new.
	t4 x: t1.
	t4 y: t2.
	t4 model: t3.
	^ t4! !

!RzDummy methodsFor: 'comparing' stamp: ''!
= aRzDummy 
	^ model = aRzDummy model! !

!RzDummy methodsFor: 'accessing' stamp: ''!
hasLast
	^ last notNil! !

!RzDummy methodsFor: 'accessing' stamp: ''!
last
	^ last! !

!RzDummy methodsFor: 'accessing' stamp: ''!
last: anObject 
	last := anObject! !

!RzDummy methodsFor: 'accessing' stamp: ''!
model
	^ model! !

!RzDummy methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 20:00'!
model: anObject
	model := anObject! !

!RzDummy methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 20:00'!
printOn: aStream
	"delegate resposability"
	model ifNotNil: [model printOn: aStream]! !

!RzDummy methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 20:00'!
printString
	
	model ifNil: [^ ''].
	^ model printString! !

!RzDummy methodsFor: 'accessing' stamp: ''!
x
	^ x! !

!RzDummy methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 20:01'!
x: anInteger 
	x := anInteger! !

!RzDummy methodsFor: 'accessing' stamp: ''!
y
	^ y! !

!RzDummy methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 20:01'!
y: anInteger
	y := anInteger! !

Object subclass: #RzMerge
	instanceVariableNames: 'packages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Core'!

!RzMerge class methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 22:19'!
packages: alist
	|inst|
	inst := self new.
	inst packages: alist.
	^ inst.! !

!RzMerge methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 6/10/2012 14:02'!
classes
	|cs|
	cs := OrderedCollection new.
	self packages do:[ :pkg| cs addAll: (pkg classes)].
	^ cs.! !

!RzMerge methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 6/10/2012 14:02'!
methods
	|ms|
	ms := OrderedCollection new.
	self classes do:[ :cls| ms addAll: (cls methods)].
	^ ms.! !

!RzMerge methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 22:19'!
packages

	^ packages! !

!RzMerge methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 22:19'!
packages: anObject

	packages := anObject! !

RzVisualizer subclass: #RzNode
	instanceVariableNames: 'old new rizel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Core'!

RzNode subclass: #RzClass
	instanceVariableNames: 'methods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Core'!

!RzClass methodsFor: 'initialize-release' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 22:12'!
build
	"merging methods of new and old"
	| names newClasses oldClasses |
	names := Set new.
	newClasses := self property:#methods from:#new ifAbsent:[OrderedCollection new].
	oldClasses := self property:#methods from:#old ifAbsent:[OrderedCollection new].
	names addAll: (newClasses collect:#selector).
	names addAll: (oldClasses collect:#selector).
	names do: [:name | 
			| a b|
			b := newClasses select: [:cls | cls selector = name].
			b := b isEmpty ifTrue:[ nil ] ifFalse: [b anyOne].
			a := oldClasses select: [:cls | cls selector = name].
			a := a isEmpty ifTrue:[ nil ] ifFalse: [a anyOne].
			methods add: (RzMethod old: a new: b owner: rizel)].! !

!RzClass methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 20:05'!
className
	^ self property: #className ifAbsent: [''].! !

!RzClass methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	methods := OrderedCollection new! !

!RzClass methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 20:03'!
methods
	^ methods! !

RzNode subclass: #RzMethod
	instanceVariableNames: 'outcommingCalls visited'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Core'!

!RzMethod methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 22:36'!
allOutgoingMethods
	""
	|stack list|
	stack := Stack new.
	stack push: self.
	list := OrderedCollection new.
	rizel methods do:[ :m | m visited: false.].
	[stack notEmpty] whileTrue: [
		|method|
		method := stack pop.
		method visited: true.
		list add: method.
		method outgoingCalls do:[ :m | 
			m visited ifFalse: [ stack push: m.].].
	].
	^ list.
	"^ methods select:[ :m |
			(m hasDifferent: #copySourceCode) or:[
			(m property: #isCovered ifAbsent:[false]) and:[
			(m hasDifferent: #executionTime)] ]]."
	! !

!RzMethod methodsFor: 'as yet unclassified' stamp: 'JPSA 6/21/2012 01:48'!
analize
	""
	|view set v|
	view := MOViewRenderer new.
	v := RzVisualizerDiffGraph new.
	set := self allOutgoingMethods asSet.
		view shape rectangle
					width: [ :m |  (v diff:#numberOfExecutions on: m) log * 10];
					height: [ :m |  ((v diff:#numberOfCalls on: m) log) * 10 ];
					fillColor: [ :m | v colorFor:m ];
					borderColor: [ :m | v borderColorFor:m];
					borderWidth:[:m| 1].
	view nodes: (set).
	"view edges: (self methods)  from:#yourself toAll: [ :rzm | rzm incomingCalls]."
	view shape arrowedLine.
	view edges: (set)  from:#yourself toAll: [ :rzm | rzm outgoingCalls.].
	view sugiyamaLayout.
	view open.! !

!RzMethod methodsFor: 'actions' stamp: 'JuanPabloSandovalA 6/10/2012 15:37'!
browse
	| morph |
	morph := DiffMorph from: (self oldSourceCode) to: (self newSourceCode).
	morph openInWindow.! !

!RzMethod methodsFor: 'initialize-release' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 20:23'!
build
	^ self! !

!RzMethod methodsFor: 'as yet unclassified' stamp: 'JPSA 6/20/2012 23:43'!
hasDifferentSourceCode
	^self hasDifferent:#copySourceCode.! !

!RzMethod methodsFor: 'as yet unclassified' stamp: 'JPSA 6/20/2012 23:36'!
hasDifferentSourceCode2
	^ (self removeComments: (self oldSourceCode)) ~= (self removeComments: (self newSourceCode)).! !

!RzMethod methodsFor: 'accesing' stamp: 'JuanPabloSandovalA 6/10/2012 14:01'!
incomingCalls
	|result allMethods|
	result := OrderedCollection new.
	new ifNil:[ ^ result].
	new incomingCalls do:[ : nm|
		|set|
		set :=  rizel methods select: [ :rm |  rm new == nm].
		set isEmpty ifFalse:[ result add: (set anyOne). ]. ].
	^ result.
	

	! !

!RzMethod methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 6/11/2012 00:09'!
initialize 
	super initialize.
	visited := true.! !

!RzMethod methodsFor: 'accesing' stamp: 'JPSA 6/21/2012 00:07'!
newSourceCode
	"return new method source code"
	^ self property:#copySourceCode from: #new ifAbsent: [''].! !

!RzMethod methodsFor: 'accesing' stamp: 'JPSA 6/21/2012 00:07'!
oldSourceCode
	"return old method source code"
	^self property:#copySourceCode from: #old ifAbsent: [''].! !

!RzMethod methodsFor: 'accesing' stamp: 'JuanPabloSandovalA 6/10/2012 14:01'!
outgoingCalls
	|result allMethods|
	result := OrderedCollection new.
	new ifNil:[ ^ result].
	new outgoingCalls do:[ : nm|
		|set|
		set :=  rizel methods select: [ :rm |  rm new == nm].
		set isEmpty ifFalse:[ result add: (set anyOne). ]. ].
	^ result.

	! !

!RzMethod methodsFor: 'as yet unclassified' stamp: 'JPSA 6/21/2012 00:06'!
removeComments: aByteString
	|temp newString pivote flag|
	temp := aByteString.
	
	newString := String streamContents: [ :s|
		flag := true.
		temp do:[ :char|
			char = $" ifTrue:[ flag := flag not.] 
			ifFalse:[ flag ifTrue:[ 
				((Character cr = char) or:[ char = (Character value:39)]) ifFalse:[
					(Character tab = char) 
						ifTrue:[" s nextPut: (Character space)"]
						ifFalse:[ s nextPut: char ]. ].].]].
	].

	^ newString withoutLeadingBlanks.! !

!RzMethod methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 6/11/2012 00:00'!
visited
	^ visited.! !

!RzMethod methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 6/11/2012 00:00'!
visited: flag
	visited := flag.! !

!RzNode class methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 22:09'!
old: oldNode new: newNode
	| node |
	node := self new.
	node old: oldNode.
	node new: newNode.
	node build.
	^ node! !

!RzNode class methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 22:11'!
old: oldNode new: newNode owner: rizelObject
	| node |
	node := self new.
	node old: oldNode.
	node new: newNode.
	node rizel: rizelObject.
	node build.
	^ node! !

!RzNode methodsFor: 'initialize-release' stamp: ''!
build
	^ self! !

!RzNode methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 19:55'!
hasDifferent: aSymbol
	"return if has different aSymbol property"
	
	^ (self property: aSymbol from:#old) ~=  (self property: aSymbol from:#new) .! !

!RzNode methodsFor: 'accessing' stamp: ''!
new
	^ new! !

!RzNode methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 19:58'!
new: newestNode 
	" newest node"
	new := newestNode! !

!RzNode methodsFor: 'accessing' stamp: ''!
old
	^ old! !

!RzNode methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 19:57'!
old: olderNode
	old := olderNode! !

!RzNode methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 19:56'!
printString
	^ self property: #printString from:#old ifAbsent:[
			self property: #printString from:#new ifAbsent:['']. ].! !

!RzNode methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 20:05'!
property: aSymbol
	^ self property: aSymbol  ifAbsent: [nil]
		! !

!RzNode methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 19:56'!
property: aSymbol from: target
	"return target property"
	^ self property: aSymbol from: target ifAbsent: [ nil ]. ! !

!RzNode methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 19:56'!
property: aSymbol from: target ifAbsent: aBlock
	"return target property"
	|obj|
	obj := self perform: target.
	obj ifNil: [ ^ aBlock value].
	^ (self perform: target) perform: aSymbol.! !

!RzNode methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 20:05'!
property: aSymbol ifAbsent: aBlock
	^ self property: aSymbol from:#new ifAbsent:[
		self property: aSymbol from:#old ifAbsent: aBlock
		]! !

!RzNode methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 22:11'!
rizel
	^  rizel.! !

!RzNode methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 22:11'!
rizel: aObject
	 rizel:= aObject.! !

RzNode subclass: #RzPackage
	instanceVariableNames: 'classes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Core'!

!RzPackage methodsFor: 'initialize-release' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 22:12'!
build
	"merging classes of new and old"
	| names newClasses oldClasses |
	names := Set new.
	newClasses := self property:#classes from:#new ifAbsent:[OrderedCollection new].
	oldClasses := self property:#classes from:#old ifAbsent:[OrderedCollection new].
	names addAll: (newClasses collect:#className).
	names addAll: (oldClasses collect:#className).
	names do: [:name | 
			| a b|
			b := newClasses select: [:cls | cls className = name].
			b := b isEmpty ifTrue:[ nil ] ifFalse: [b anyOne].
			a := oldClasses select: [:cls | cls className = name].
			a := a isEmpty ifTrue:[ nil ] ifFalse: [a anyOne].
			classes add: (RzClass old: a new: b owner: rizel)].! !

!RzPackage methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 20:07'!
classes
	^ classes.! !

!RzPackage methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	classes := OrderedCollection new! !

!RzPackage methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 20:10'!
methods
	| ms |
	ms := OrderedCollection new.
	self classes do: [:c | ms addAll: c methods].
	^ ms.! !

!RzPackage methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 20:10'!
packageName
	"package Name"
	^ self perform:#packageName ifAbsent: [ ''].! !
